package io.confluent.kafkarest.entities.v3;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.time.Instant;
import java.util.Optional;
import javax.annotation.Generated;
import javax.annotation.Nullable;

@Generated("com.google.auto.value.processor.AutoValueProcessor")
final class AutoValue_ProduceBatchResponseSuccessEntry extends ProduceBatchResponseSuccessEntry {

  private final String id;

  private final Optional<String> clusterId;

  private final Optional<String> topicName;

  private final Integer partitionId;

  private final Long offset;

  private final Optional<Instant> timestamp;

  private final Optional<ProduceResponse.ProduceResponseData> key;

  private final Optional<ProduceResponse.ProduceResponseData> value;

  private AutoValue_ProduceBatchResponseSuccessEntry(
      String id,
      Optional<String> clusterId,
      Optional<String> topicName,
      @Nullable Integer partitionId,
      @Nullable Long offset,
      Optional<Instant> timestamp,
      Optional<ProduceResponse.ProduceResponseData> key,
      Optional<ProduceResponse.ProduceResponseData> value) {
    this.id = id;
    this.clusterId = clusterId;
    this.topicName = topicName;
    this.partitionId = partitionId;
    this.offset = offset;
    this.timestamp = timestamp;
    this.key = key;
    this.value = value;
  }

  @JsonProperty("id")
  @Override
  public String getId() {
    return id;
  }

  @JsonProperty("cluster_id")
  @JsonInclude(JsonInclude.Include.NON_ABSENT)
  @Override
  public Optional<String> getClusterId() {
    return clusterId;
  }

  @JsonProperty("topic_name")
  @JsonInclude(JsonInclude.Include.NON_ABSENT)
  @Override
  public Optional<String> getTopicName() {
    return topicName;
  }

  @JsonProperty("partition_id")
  @JsonInclude(JsonInclude.Include.NON_NULL)
  @Nullable
  @Override
  public Integer getPartitionId() {
    return partitionId;
  }

  @JsonProperty("offset")
  @JsonInclude(JsonInclude.Include.NON_NULL)
  @Nullable
  @Override
  public Long getOffset() {
    return offset;
  }

  @JsonProperty("timestamp")
  @JsonInclude(JsonInclude.Include.NON_ABSENT)
  @Override
  public Optional<Instant> getTimestamp() {
    return timestamp;
  }

  @JsonProperty("key")
  @JsonInclude(JsonInclude.Include.NON_ABSENT)
  @Override
  public Optional<ProduceResponse.ProduceResponseData> getKey() {
    return key;
  }

  @JsonProperty("value")
  @JsonInclude(JsonInclude.Include.NON_ABSENT)
  @Override
  public Optional<ProduceResponse.ProduceResponseData> getValue() {
    return value;
  }

  @Override
  public String toString() {
    return "ProduceBatchResponseSuccessEntry{"
        + "id=" + id + ", "
        + "clusterId=" + clusterId + ", "
        + "topicName=" + topicName + ", "
        + "partitionId=" + partitionId + ", "
        + "offset=" + offset + ", "
        + "timestamp=" + timestamp + ", "
        + "key=" + key + ", "
        + "value=" + value
        + "}";
  }

  @Override
  public boolean equals(Object o) {
    if (o == this) {
      return true;
    }
    if (o instanceof ProduceBatchResponseSuccessEntry) {
      ProduceBatchResponseSuccessEntry that = (ProduceBatchResponseSuccessEntry) o;
      return this.id.equals(that.getId())
          && this.clusterId.equals(that.getClusterId())
          && this.topicName.equals(that.getTopicName())
          && (this.partitionId == null ? that.getPartitionId() == null : this.partitionId.equals(that.getPartitionId()))
          && (this.offset == null ? that.getOffset() == null : this.offset.equals(that.getOffset()))
          && this.timestamp.equals(that.getTimestamp())
          && this.key.equals(that.getKey())
          && this.value.equals(that.getValue());
    }
    return false;
  }

  @Override
  public int hashCode() {
    int h$ = 1;
    h$ *= 1000003;
    h$ ^= id.hashCode();
    h$ *= 1000003;
    h$ ^= clusterId.hashCode();
    h$ *= 1000003;
    h$ ^= topicName.hashCode();
    h$ *= 1000003;
    h$ ^= (partitionId == null) ? 0 : partitionId.hashCode();
    h$ *= 1000003;
    h$ ^= (offset == null) ? 0 : offset.hashCode();
    h$ *= 1000003;
    h$ ^= timestamp.hashCode();
    h$ *= 1000003;
    h$ ^= key.hashCode();
    h$ *= 1000003;
    h$ ^= value.hashCode();
    return h$;
  }

  static final class Builder extends ProduceBatchResponseSuccessEntry.Builder {
    private String id;
    private Optional<String> clusterId = Optional.empty();
    private Optional<String> topicName = Optional.empty();
    private Integer partitionId;
    private Long offset;
    private Optional<Instant> timestamp = Optional.empty();
    private Optional<ProduceResponse.ProduceResponseData> key = Optional.empty();
    private Optional<ProduceResponse.ProduceResponseData> value = Optional.empty();
    Builder() {
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setId(String id) {
      if (id == null) {
        throw new NullPointerException("Null id");
      }
      this.id = id;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setClusterId(Optional<String> clusterId) {
      if (clusterId == null) {
        throw new NullPointerException("Null clusterId");
      }
      this.clusterId = clusterId;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setClusterId(@Nullable String clusterId) {
      this.clusterId = Optional.ofNullable(clusterId);
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setTopicName(Optional<String> topicName) {
      if (topicName == null) {
        throw new NullPointerException("Null topicName");
      }
      this.topicName = topicName;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setTopicName(@Nullable String topicName) {
      this.topicName = Optional.ofNullable(topicName);
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setPartitionId(@Nullable Integer partitionId) {
      this.partitionId = partitionId;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setOffset(@Nullable Long offset) {
      this.offset = offset;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setTimestamp(Optional<Instant> timestamp) {
      if (timestamp == null) {
        throw new NullPointerException("Null timestamp");
      }
      this.timestamp = timestamp;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setTimestamp(@Nullable Instant timestamp) {
      this.timestamp = Optional.ofNullable(timestamp);
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setKey(Optional<ProduceResponse.ProduceResponseData> key) {
      if (key == null) {
        throw new NullPointerException("Null key");
      }
      this.key = key;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setKey(@Nullable ProduceResponse.ProduceResponseData key) {
      this.key = Optional.ofNullable(key);
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setValue(Optional<ProduceResponse.ProduceResponseData> value) {
      if (value == null) {
        throw new NullPointerException("Null value");
      }
      this.value = value;
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry.Builder setValue(@Nullable ProduceResponse.ProduceResponseData value) {
      this.value = Optional.ofNullable(value);
      return this;
    }
    @Override
    public ProduceBatchResponseSuccessEntry build() {
      String missing = "";
      if (this.id == null) {
        missing += " id";
      }
      if (!missing.isEmpty()) {
        throw new IllegalStateException("Missing required properties:" + missing);
      }
      return new AutoValue_ProduceBatchResponseSuccessEntry(
          this.id,
          this.clusterId,
          this.topicName,
          this.partitionId,
          this.offset,
          this.timestamp,
          this.key,
          this.value);
    }
  }

}
